﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	import mx.utils.ObjectUtil;
	
	
	import com.actionscriptfacile.ui.text.UITextField;
	

	import flash.display.LoaderInfo;
	import flash.text.TextField;
	import flash.net.URLRequest;
	import flash.events.IOErrorEvent;
	import flash.display.Loader;
	import flash.events.Event;
	import flash.display.Sprite;
	import flash.text.TextFormat;
	import flash.text.AntiAliasType;
	import flash.text.Font;
		
	
	import com.demonsters.debugger.MonsterDebugger;


	public class Main extends Sprite
	{
		private var oTxtInfo : UITextField;
		
		
		/**
		 * Constructeur.
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 40
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);

			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start Application");
			
			this.setupUI();
			this.loadFont("http://www.actionscript-facile.com/ressources/swf/ExterneFont.swf?nocache="+Math.random()*34);
		}

	
		/**
		 * Création de l'interface utilisateur.
		 * 
		 */
		private function setupUI() : void
		{			
			oTxtInfo = this.addText("Chargement des polices de caractères...");
			oTxtInfo.x = 34;
			oTxtInfo.y = 10;
			this.addChild(oTxtInfo);			
		}


		private function loadFont(url : String) : void
		{
			MonsterDebugger.trace(this,"loadFont : "+url);
			var loader : Loader = new Loader();
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, onLoadComplete);
			loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onLoadError);
			loader.load( new URLRequest( url ) );
		}


		/**
		 * Le swf de fonts est chargé.
		 * 
		 */
		private function onLoadComplete(event : Event) : void
		{
			MonsterDebugger.trace(this,"onLoadComplete");
			MonsterDebugger.trace(this,event);
			
			// créer une instance de la classe contenant les polices
			var FontLibrary:Class = event.target.applicationDomain.getDefinition("ExterneFont") as Class;
			
			// enregistre les polices contenant dans la classe
			var fl:Object = ObjectUtil.copy(FontLibrary);
			for(var i:Object in fl)
				Font.registerFont(FontLibrary[i]);

            //Font.registerFont(FontLibrary._Font);// enregistre une seule font
			
			MonsterDebugger.trace( this,Font.enumerateFonts() );
			
			oTxtInfo.embedFonts = true;
			oTxtInfo.defaultTextFormat = new TextFormat("Charming", 34, 0x006f77);
			oTxtInfo.antiAliasType = AntiAliasType.ADVANCED;
			oTxtInfo.rotation = 13;
			oTxtInfo.y = 0;
			oTxtInfo.htmlText = "&é#àçèëê@€... <font size='43'><b>AS3 Facile</b></font>\n" +
			"Des <font size='63'><i>caractères accentués en italique</i></font>\n" +
			" des chiffres : <font size='63'><i><b>1234567890</b></i></font>!!!";
			
			MonsterDebugger.trace(this,"finish");
		}
		
	
		
		/**
		 * Gestion des erreurs de chargement.
		 * 
		 */
		private function onLoadError(e:IOErrorEvent):void 
		{
			MonsterDebugger.trace(this,"erreur de chargement : " + e.text);
			MonsterDebugger.trace(this,e);
			
			var contentLoaderInfo:LoaderInfo = LoaderInfo( e.target);
			contentLoaderInfo.removeEventListener(Event.COMPLETE, onLoadComplete );
			contentLoaderInfo.removeEventListener(IOErrorEvent.IO_ERROR, onLoadError );
			
			
			var text:TextField = addChild( new TextField() ) as TextField;
			text.width = stage.stageWidth;
			text.autoSize = 'center';
			text.text = "Erreur de chargement : "+e.text;
		}
		
		
		
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeLeft();
			oTxtField.alignLeft(); // centre le texte
			oTxtField.changeFormat("size", 18);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x006f77);// changement de la couleur
			
			return oTxtField;	 
		}
		
	}
}
